#include <iostream>
#include <fstream>
#include <cstring>
#include <cstdlib>
#include <cmath>
#include <string>

using namespace std;

extern QStringList Switches;

QList<float> testValues;
float minP = 9999.0, P1=-9.0, P2=-9.0, P3=-9.0, fractP=-1.0;
int fractPcount=-1;

float **myTable;
int cols, rows;



void combMatrix(int one, int two, int three, float step, float consider_limit)//fits 3 populations
{

if(consider_limit>1.0) consider_limit=1.0;
if(consider_limit<0.0) consider_limit=0.0;

float totold=0.0, slope=0.0, oldslope=0.0;
int i, count=0;
QList<float> Mins,Mins2, Maxs,minP1,minP2,minP3;

          float k,kk,kkk;
          int j, n, nn, nnn, intstep = (int)(1000.0*step);
          minP = 9999.0; P1=-9.0; P2=-9.0; P3=-9.0;
          for(n=0; n<1000+intstep; n=n+intstep)
          {
            for(nn=0; nn<1000+intstep; nn=nn+intstep)
            { 
              nnn=1000-n-nn;
              float difference=0.0; float totdifference=0.0;

                if(nnn>=0)
                {       
                k=n/1000.0; kk=nn/1000.0; kkk=nnn/1000.0;         
                
                for(j=0; j<cols; j++)
                {
                difference=(   kkk*myTable[j][three] + kk*myTable[j][two] + k*myTable[j][one] ) - testValues.at(j);
                if(difference<0) difference*=-1;
                totdifference+=difference;
                }

                
////find all max and min values

slope=totdifference-totold;

if(count==1)
{
if(slope>0) {Mins.append(totold); Mins2.append(totold); minP1.append(k); minP2.append(kk); minP3.append(kkk);}
}
  
else if(count>0)
{
if(slope<0 && oldslope>0) {Maxs.append(totold);}
else if(slope>0 && oldslope<0) {Mins.append(totold); Mins2.append(totold); minP1.append(k); minP2.append(kk); minP3.append(kkk);}
else{;}
}

else {;}



oldslope = slope; totold=totdifference; count+=1;

                
                }
         
            }
          }
          
if(slope<0) {Mins.append(totold); Mins2.append(totold); minP1.append(k); minP2.append(kk); minP3.append(kkk);}
     
     
////process all max and min valus to calculate fractP (the smaller the better)

if(Mins.size()>0)
{
qSort(Mins); 
qSort(Maxs);
float lowest = Mins.at(0);
float delta = Mins.at(Mins.size()-1) - lowest;


i=0; while( Mins.at(i)<= ( lowest+(delta*consider_limit) ) ) i++;  if(i<1) i=1;

fractPcount=i;
fractP=(float)i/(float)Mins.size()*100.0;
float threshold=Mins.at(i);

count=0; float sumScore=0.0, sumP1=0.0, sumP2=0.0, sumP3=0.0;
for(i=0; i<Mins2.size(); i++)
{
  if(Mins2.at(i)<=threshold)
  {
   count+=1; sumScore+=Mins2.at(i); sumP1+=minP1.at(i); sumP2+=minP2.at(i); sumP3+=minP3.at(i);
  }
}


minP=sumScore/count; P1=sumP1/count; P2=sumP2/count; P3=sumP3/count;
}
else minP=P1=P2=P3=-1.0;

Mins.clear(); Mins2.clear(); Maxs.clear(); minP1.clear(); minP2.clear(); minP3.clear();
}



void combMatrix_finetuning(int one, int two, int three, float step, float consider_limit)//fits 3 populations
{

if(consider_limit>1.0) consider_limit=1.0;
if(consider_limit<0.0) consider_limit=0.0;

int i, count=0;
QList<float> Mins,Mins2,minP1,minP2,minP3;


          float k,kk,kkk;
          int j, n, nn, nnn, intstep = (int)(1000.0*step);
          minP = 9999.0; P1=-9.0; P2=-9.0; P3=-9.0;
          for(n=0; n<1000+intstep; n=n+intstep)
          {
            for(nn=0; nn<1000+intstep; nn=nn+intstep)
            { 
              nnn=1000-n-nn;
              float difference=0.0; float totdifference=0.0;

                if(nnn>=0)
                {       
                k=n/1000.0; kk=nn/1000.0; kkk=nnn/1000.0;         
                
                for(j=0; j<cols; j++)
                {
                difference=(   kkk*myTable[j][three] + kk*myTable[j][two] + k*myTable[j][one] ) - testValues.at(j);
                if(difference<0) difference*=-1;
                totdifference+=difference;
                }

               Mins.append(totdifference); Mins.append(totdifference); Mins2.append(totdifference); minP1.append(k); minP2.append(kk); minP3.append(kkk);
                        
                }
         
            }
          }
          
////process all max and min valus to calculate fractP (the smaller the better)

qSort(Mins); 
float lowest = Mins.at(0);
float delta = Mins.at(Mins.size()-1) - lowest;


i=0; while( Mins.at(i)<= ( lowest+(delta*consider_limit) ) ) i++;  if(i<1) i=1;

fractPcount=i;
fractP=(float)i/(float)Mins.size()*100.0;
float threshold=Mins.at(i);

count=0; float sumScore=0.0, sumP1=0.0, sumP2=0.0, sumP3=0.0; //SELECTION OPTION 2 start
for(i=0; i<Mins2.size(); i++)
{
  if(Mins2.at(i)<=threshold)
  {
   count+=1; sumScore+=Mins2.at(i); sumP1+=minP1.at(i); sumP2+=minP2.at(i); sumP3+=minP3.at(i);
  }
}


minP=sumScore/count; P1=sumP1/count; P2=sumP2/count; P3=sumP3/count;//SELECTION OPTION 2 end


Mins.clear(); Mins2.clear(); minP1.clear(); minP2.clear(); minP3.clear();
}


void combMatrix2(int one, int two, float step)
{
          float k,kkk;
          int j, n, nnn, intstep = (int)(1000.0*step);
          minP = 9999.0; P1=-9.0; P2=-9.0; P3=0.0;
          for(n=0; n<1000+intstep; n=n+intstep)
          {

              nnn=1000-n; 
              float difference=0.0; float totdifference=0.0;

                if(nnn>=0)
                {       
                k=n/1000.0; kkk=nnn/1000.0;         

                for(j=0; j<cols; j++)
                {
                difference=(   kkk*myTable[j][two] + k*myTable[j][one] ) - testValues.at(j);
                if(difference<0) difference*=-1;
                totdifference+=difference;
                }
                if(totdifference<minP){minP=totdifference; P1=k; P2=kkk;}
                }//if
         
          }//n
          
          
}


void combMatrix1(int one, float step)//fits 1 population
{
          int j;
          minP = 9999.0; P1=-9.0; P2=0.0; P3=0.0;
    
              float difference=0.0; float totdifference=0.0;       

                for(j=0; j<cols; j++)
                {
                difference= myTable[j][one]  - testValues.at(j);
                if(difference<0) difference*=-1;
                totdifference+=difference;
                }
                if(totdifference<minP){minP=totdifference; P1=1.0;}
}


void mixFit()
{
  
int f, i, j,m;

///////input
f=Switches.indexOf("-file"); QString Filename=Switches.at(f+1);
if(f<0 || Filename==0){ cout<<"You need to specify '-file'.\n\n"; exit(1);}

f=Switches.indexOf("-out"); QString Outname=Switches.at(f+1);
if(f<0 || Outname==0) 
{
Outname=Filename; Outname.append(".out");
}

f=Switches.indexOf("-ref"); QString Refname=Switches.at(f+1);
if(f<0 || Refname==0){ cout<<"You need to specify '-ref'.\n\n"; exit(1);}


f=Switches.indexOf("-delim"); QString Delimcommand = Switches.at(f+1); QString Delim;
if(f<0 || Delimcommand==0) Delim="\t";
else if(Delimcommand=="tab" || Delimcommand=="TAB") Delim="\t";
else if(Delimcommand=="space" || Delimcommand=="SPACE") Delim=" ";
else if(Delimcommand=="colon" || Delimcommand=="COLON") Delim=":";
else if(Delimcommand=="semicolon" || Delimcommand=="SEMICOLON") Delim=";";
else if(Delimcommand=="comma" || Delimcommand=="COMMA") Delim=",";
else Delim=Delimcommand;


int combinatorics=1;
f=Switches.indexOf("-combinatorics"); QString Combiverdict = Switches.at(f+1);
if(f<0 || Combiverdict==0) combinatorics=1;
else if(Combiverdict=="yes" || Combiverdict=="YES") combinatorics=1;
else if(Combiverdict=="no" || Combiverdict=="NO") combinatorics=0;
else combinatorics=1;

int choosebest=0;
f=Switches.indexOf("-choosebest");
if(f>=0 && f<Switches.size()-1) 
  {
  choosebest=Switches.at(f+1).toInt();
  }
else choosebest=0;
if(choosebest>3)choosebest=3;
if(choosebest<0)choosebest=0;

int headeryes=0;
f=Switches.indexOf("-header"); QString Headerverdict = Switches.at(f+1);
if(f<0 || Headerverdict==0) headeryes=0;
else if(Headerverdict=="yes" || Headerverdict=="YES") headeryes=1;
else if(Headerverdict=="no" || Headerverdict=="NO") headeryes=0;
else headeryes=0;


int refheaderyes=0;
f=Switches.indexOf("-refheader"); QString Refheaderverdict=Switches.at(f+1);
if(f<0 || Refheaderverdict ==0) refheaderyes=0;
else if(Refheaderverdict=="yes" || Refheaderverdict=="YES") refheaderyes=1;
else if(Refheaderverdict=="no" || Refheaderverdict=="NO") refheaderyes=0;
else refheaderyes=0;

f=Switches.indexOf("-missing"); QString Missing = Switches.at(f+1);
if(f<0 || Missing==0) Missing="NA";
else if(Missing=="none" || Missing =="NONE") {Missing="";}
else {;}

int refpops=0;
f=Switches.indexOf("-refpops"); QString Refpops=Switches.at(f+1);
if(f>=0 && f<Switches.size()-1) 
  {
  refpops=Refpops.toInt();
  }
else refpops=0;
if(refpops<3){cout << "You have less than 3 ref populations\n"; exit(1);}
cols=refpops; rows=refpops;

float plimit=0.0;
f=Switches.indexOf("-plimit"); QString Plimit=Switches.at(f+1);
if(f>=0 && f<Switches.size()-1) 
{
plimit = Plimit.toFloat();
}

float step = 0.05;
f=Switches.indexOf("-step"); QString Step=Switches.at(f+1);
if(f>=0 && f<Switches.size()-1) 
{
step = Step.toFloat();
}

float a1=0.1; f=Switches.indexOf("-a1");
if(f>=0 && f<Switches.size()-1) a1 = Switches.at(f+1).toFloat();
if(a1<0.0) a1=0.0; if(a1>1.0) a1=1.0; 

float a2=0.1; f=Switches.indexOf("-a2");
if(f>=0 && f<Switches.size()-1) a2 = Switches.at(f+1).toFloat();
if(a2<0.0) a2=0.0; if(a2>1.0) a2=1.0; 

float a3=0.1; f=Switches.indexOf("-a3");
if(f>=0 && f<Switches.size()-1) a3 = Switches.at(f+1).toFloat();
if(a3<0.0) a3=0.0; if(a3>1.0) a3=1.0; 

////start
cout << "running mixFit()\n\n";
QString oneRow, entry;
QStringList list1;

QFile reffile(Refname); if(!reffile.open(QIODevice::ReadOnly | QIODevice::Text)) {exit(1);}
QTextStream ref_stream(&reffile);

QFile outfile(Outname); if(!outfile.open(QIODevice::WriteOnly | QIODevice::Text)) {exit(1);}
QTextStream out_stream(&outfile);

QFile infile(Filename); if(!infile.open(QIODevice::ReadOnly | QIODevice::Text)) {exit(1);}
QTextStream in_stream(&infile);

//Read reference file

myTable = (float**) malloc((cols+2) * sizeof(float*)); if(myTable == NULL) {exit(1);}
for(i = 0; i < cols+1; i++) {myTable[i] = (float*)malloc((rows+2) * sizeof(float)); if(myTable[i] == NULL) {exit(1);}}
for(i=0; i<cols+1; i++){for(j=0; j<rows+2; j++){myTable[i][j]=0.0;}}  //myTable[columns][rows]=0.5;

if(!ref_stream.atEnd() && refheaderyes==1) {
                                       QString RefHeader = ref_stream.readLine(); RefHeader.clear();
                                       }//REFHEADER
QStringList refIDList;
int rowcounter=0;
while(!ref_stream.atEnd())
{
  oneRow = ref_stream.readLine();

  if(!oneRow.isEmpty())
  {
  list1 = oneRow.split(Delim);
  refIDList.append(list1.at(0));
    for(i=1; i<list1.size(); i++)
    {
    myTable[i-1][rowcounter]=list1.at(i).toFloat();
    }
  rowcounter+=1;

  }   
}

//Analysis
QStringList EST, REF;
QList<float> SIM;
QList<int> ESTloc, REFloc;

if(!in_stream.atEnd() && headeryes==1) {
                                       QString Header = in_stream.readLine(); Header.clear();
                                       }//HEADER

int counter=0;

QList<double> cumulResults; for(i=0; i<rows; i++) cumulResults.append(0.0);
QList<double> cumulResults_select; for(i=0; i<rows; i++) cumulResults_select.append(0.0);

while(!in_stream.atEnd())
{
  oneRow = in_stream.readLine();

  if(!oneRow.isEmpty())
  {
  list1 = oneRow.split(Delim);

    for(i=1; i<list1.size(); i++){testValues.append(list1.at(i).toFloat());}

    EST.append(list1.at(0)); REF.append("NA"); ESTloc.append(counter); REFloc.append(-9); SIM.append(999999.9);


    //Do comparison (find closest population and values for all populations)
    float difference=0.0, totdifference=0.0; QList<float> popValues;
    for(i=0; i<rows; i++)
    {
       totdifference=0.0;
       for(j=0; j<cols; j++)
       {
       difference=myTable[j][i]-testValues.at(j);
       if(difference<0) difference*=-1;
       totdifference+=difference;
       }

       if(totdifference<SIM.at(counter)) {REF[counter]=refIDList.at(i); REFloc[counter]=i; SIM[counter]=totdifference;}
       popValues.append(totdifference);
    }


   ////OPTION 0, rank all populations individually

   float minpopval=9999.9; int minpop_loc=-9; QList<int> bestList;

   for(j=0; j<rows; j++)
   {
     minpopval=9999.9; minpop_loc=-9;
     for(i=0; i<rows; i++)
     {
     if(popValues.at(i)<minpopval){minpopval=popValues.at(i); minpop_loc=i;}
     }
     popValues[minpop_loc]=9999.9;
     bestList.append(minpop_loc);
   }

   popValues.clear();

   
       
       ////////////////////////
       ///COMBINATIONS = 3
       ////////////////////////
       if(combinatorics==1)
       {
	 

	 
QList<float> Mins,Mins2,mP1,mP2,mP3,minP1,minP2,minP3;	 


       int p,q,r; int pop1,pop2,pop3;
       float pop_minP = 9999.0, pop_P1=-9.0, pop_P2=-9.0, pop_P3=-9.0;
       float minscore=9999.0;
       
//find candidates
       if(choosebest==0)
       {
       for(p=0;p<refpops; p++){
       for(q=p+1;q<refpops; q++){
       for(r=q+1;r<refpops; r++){
         combMatrix(p, q, r, step, a1);//¤¤¤¤¤¤¤¤¤¤
	 

	 if(minP>=0){Mins.append(minP); Mins2.append(minP); mP1.append(p); mP2.append(q); mP3.append(r); minP1.append(P1); minP2.append(P2); minP3.append(P3);}      
       }}}}

       else if(choosebest==1)
       {
       p=bestList.at(0);
       for(q=0;q<refpops; q++){
       for(r=q+1;r<refpops; r++){
         if(p!=q && p!=r)combMatrix(p, q, r, step, a1);//¤¤¤¤¤¤¤¤¤¤
	 if(minP>=0){Mins.append(minP); Mins2.append(minP); mP1.append(p); mP2.append(q); mP3.append(r); minP1.append(P1); minP2.append(P2); minP3.append(P3);}
       }}}

       else if(choosebest==2)
       {
       p=bestList.at(0);
       q=bestList.at(1);
       for(r=0;r<refpops; r++){
         if(r!=p && r!=q)combMatrix(p, q, r, step, a1);//¤¤¤¤¤¤¤¤¤¤
	 if(minP>=0){Mins.append(minP); Mins2.append(minP); mP1.append(p); mP2.append(q); mP3.append(r); minP1.append(P1); minP2.append(P2); minP3.append(P3);}
       }}
 
       else
       {
       p=bestList.at(0);
       q=bestList.at(1);
       r=bestList.at(2);

         combMatrix(p, q, r, step, a1);//¤¤¤¤¤¤¤¤¤¤
	 if(minP>=0){Mins.append(minP); Mins2.append(minP); mP1.append(p); mP2.append(q); mP3.append(r); minP1.append(P1); minP2.append(P2); minP3.append(P3);}
       }
   
   
   out_stream << list1.at(0) << " "; 
   out_stream << " fractP1: "<< fractP << " fractPcount1: " << fractPcount << " ";
   
   

QList<float> Assignments; for(i=0;i<refpops; i++) Assignments.append(0.0);
   
if(choosebest<3)
{  


qSort(Mins); 
float lowest = Mins.at(0);
float delta = Mins.at(Mins.size()-1) - lowest;

i=0; while( Mins.at(i)< ( lowest+(delta*a2) ) ) i++; if(i<1) i=1; //else if(i>20) i=20; else {;} //¤¤¤¤¤¤¤¤¤¤
fractPcount=i;
fractP=(float)i/(float)Mins.size()*100.0;
float threshold=Mins.at(i);

int count=0; float sumScore=0.0; 
for(i=0; i<Mins2.size(); i++)
{
  if(Mins2.at(i)<threshold)
  {
   count+=1; 
   Assignments[mP1.at(i)]+=minP1.at(i); Assignments[mP2.at(i)]+=minP2.at(i); Assignments[mP3.at(i)]+=minP3.at(i);
  }
}

Mins.clear(); Mins2.clear(); mP1.clear(); mP2.clear(); mP3.clear(); minP1.clear(); minP2.clear(); minP3.clear();



for(j=0; j<3; j++)
{  

float maxpopval=-1.0; int maxpoploc=-1; 
  for(i=0; i<refpops; i++)
  {
  if(Assignments.at(i)>=maxpopval) {maxpopval=Assignments.at(i); maxpoploc=i;}
  }
Assignments[maxpoploc]=-1.0;
if(j==0) p=maxpoploc;
else if(j==1) q=maxpoploc;
else if(j==2) r=maxpoploc;
else {cout << "Exit combinatorics\n"; exit(1);}
}

}



combMatrix_finetuning(p, q, r, step, a3);
pop1=p; pop2=q; pop3=r; pop_minP = minP; pop_P1=P1; pop_P2=P2; pop_P3=P3;

Assignments.clear();
//OPTION2 end
       


         
         int popnumber=0;
         
         if(pop_P1>0.0) //apply plimit
         {
         cumulResults[pop1]+=pop_P1;
         out_stream << refIDList.at(pop1)<< " " << pop_P1 << " ";
         popnumber+=1;
         }

         if(pop_P2>0.0) 
         {
         cumulResults[pop2]+=pop_P2;
         out_stream << refIDList.at(pop2)<< " " << pop_P2 << " ";
         popnumber+=1;
         }


         if(pop_P3>0.0) 
         {
         cumulResults[pop3]+=pop_P3;
         out_stream << refIDList.at(pop3)<< " " << pop_P3 << " ";
         popnumber+=1;
         }
  
         if(popnumber==2) out_stream << "- - ";
         if(popnumber==1) out_stream << "- - - - ";

         out_stream << "score: "<< pop_minP << " fractP2: "<< fractP << " fractPcount2: "<< fractPcount <<"\n"; 
	 	 
	 
       }

  }

counter+=1;
testValues.clear(); 
}




//End
for(i = 0; i < cols+1; i++) {free(myTable[i]);} free(myTable);
infile.close(); outfile.close(); reffile.close(); //logfile.close();
cumulResults.clear(); cumulResults_select.clear();


}

